import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface MonitorActionGroupConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/monitor_action_group.html#enabled MonitorActionGroup#enabled}.
     *
     * @stability stable
     */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/monitor_action_group.html#name MonitorActionGroup#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/monitor_action_group.html#resource_group_name MonitorActionGroup#resource_group_name}.
     *
     * @stability stable
     */
    readonly resourceGroupName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/monitor_action_group.html#short_name MonitorActionGroup#short_name}.
     *
     * @stability stable
     */
    readonly shortName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/monitor_action_group.html#tags MonitorActionGroup#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * arm_role_receiver block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/monitor_action_group.html#arm_role_receiver MonitorActionGroup#arm_role_receiver}
     *
     * @stability stable
     */
    readonly armRoleReceiver?: MonitorActionGroupArmRoleReceiver[];
    /**
     * automation_runbook_receiver block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/monitor_action_group.html#automation_runbook_receiver MonitorActionGroup#automation_runbook_receiver}
     *
     * @stability stable
     */
    readonly automationRunbookReceiver?: MonitorActionGroupAutomationRunbookReceiver[];
    /**
     * azure_app_push_receiver block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/monitor_action_group.html#azure_app_push_receiver MonitorActionGroup#azure_app_push_receiver}
     *
     * @stability stable
     */
    readonly azureAppPushReceiver?: MonitorActionGroupAzureAppPushReceiver[];
    /**
     * azure_function_receiver block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/monitor_action_group.html#azure_function_receiver MonitorActionGroup#azure_function_receiver}
     *
     * @stability stable
     */
    readonly azureFunctionReceiver?: MonitorActionGroupAzureFunctionReceiver[];
    /**
     * email_receiver block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/monitor_action_group.html#email_receiver MonitorActionGroup#email_receiver}
     *
     * @stability stable
     */
    readonly emailReceiver?: MonitorActionGroupEmailReceiver[];
    /**
     * itsm_receiver block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/monitor_action_group.html#itsm_receiver MonitorActionGroup#itsm_receiver}
     *
     * @stability stable
     */
    readonly itsmReceiver?: MonitorActionGroupItsmReceiver[];
    /**
     * logic_app_receiver block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/monitor_action_group.html#logic_app_receiver MonitorActionGroup#logic_app_receiver}
     *
     * @stability stable
     */
    readonly logicAppReceiver?: MonitorActionGroupLogicAppReceiver[];
    /**
     * sms_receiver block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/monitor_action_group.html#sms_receiver MonitorActionGroup#sms_receiver}
     *
     * @stability stable
     */
    readonly smsReceiver?: MonitorActionGroupSmsReceiver[];
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/monitor_action_group.html#timeouts MonitorActionGroup#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: MonitorActionGroupTimeouts;
    /**
     * voice_receiver block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/monitor_action_group.html#voice_receiver MonitorActionGroup#voice_receiver}
     *
     * @stability stable
     */
    readonly voiceReceiver?: MonitorActionGroupVoiceReceiver[];
    /**
     * webhook_receiver block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/monitor_action_group.html#webhook_receiver MonitorActionGroup#webhook_receiver}
     *
     * @stability stable
     */
    readonly webhookReceiver?: MonitorActionGroupWebhookReceiver[];
}
/**
 * @stability stable
 */
export interface MonitorActionGroupArmRoleReceiver {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/monitor_action_group.html#name MonitorActionGroup#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/monitor_action_group.html#role_id MonitorActionGroup#role_id}.
     *
     * @stability stable
     */
    readonly roleId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/monitor_action_group.html#use_common_alert_schema MonitorActionGroup#use_common_alert_schema}.
     *
     * @stability stable
     */
    readonly useCommonAlertSchema?: boolean | cdktf.IResolvable;
}
export declare function monitorActionGroupArmRoleReceiverToTerraform(struct?: MonitorActionGroupArmRoleReceiver): any;
/**
 * @stability stable
 */
export interface MonitorActionGroupAutomationRunbookReceiver {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/monitor_action_group.html#automation_account_id MonitorActionGroup#automation_account_id}.
     *
     * @stability stable
     */
    readonly automationAccountId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/monitor_action_group.html#is_global_runbook MonitorActionGroup#is_global_runbook}.
     *
     * @stability stable
     */
    readonly isGlobalRunbook: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/monitor_action_group.html#name MonitorActionGroup#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/monitor_action_group.html#runbook_name MonitorActionGroup#runbook_name}.
     *
     * @stability stable
     */
    readonly runbookName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/monitor_action_group.html#service_uri MonitorActionGroup#service_uri}.
     *
     * @stability stable
     */
    readonly serviceUri: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/monitor_action_group.html#use_common_alert_schema MonitorActionGroup#use_common_alert_schema}.
     *
     * @stability stable
     */
    readonly useCommonAlertSchema?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/monitor_action_group.html#webhook_resource_id MonitorActionGroup#webhook_resource_id}.
     *
     * @stability stable
     */
    readonly webhookResourceId: string;
}
export declare function monitorActionGroupAutomationRunbookReceiverToTerraform(struct?: MonitorActionGroupAutomationRunbookReceiver): any;
/**
 * @stability stable
 */
export interface MonitorActionGroupAzureAppPushReceiver {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/monitor_action_group.html#email_address MonitorActionGroup#email_address}.
     *
     * @stability stable
     */
    readonly emailAddress: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/monitor_action_group.html#name MonitorActionGroup#name}.
     *
     * @stability stable
     */
    readonly name: string;
}
export declare function monitorActionGroupAzureAppPushReceiverToTerraform(struct?: MonitorActionGroupAzureAppPushReceiver): any;
/**
 * @stability stable
 */
export interface MonitorActionGroupAzureFunctionReceiver {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/monitor_action_group.html#function_app_resource_id MonitorActionGroup#function_app_resource_id}.
     *
     * @stability stable
     */
    readonly functionAppResourceId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/monitor_action_group.html#function_name MonitorActionGroup#function_name}.
     *
     * @stability stable
     */
    readonly functionName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/monitor_action_group.html#http_trigger_url MonitorActionGroup#http_trigger_url}.
     *
     * @stability stable
     */
    readonly httpTriggerUrl: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/monitor_action_group.html#name MonitorActionGroup#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/monitor_action_group.html#use_common_alert_schema MonitorActionGroup#use_common_alert_schema}.
     *
     * @stability stable
     */
    readonly useCommonAlertSchema?: boolean | cdktf.IResolvable;
}
export declare function monitorActionGroupAzureFunctionReceiverToTerraform(struct?: MonitorActionGroupAzureFunctionReceiver): any;
/**
 * @stability stable
 */
export interface MonitorActionGroupEmailReceiver {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/monitor_action_group.html#email_address MonitorActionGroup#email_address}.
     *
     * @stability stable
     */
    readonly emailAddress: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/monitor_action_group.html#name MonitorActionGroup#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/monitor_action_group.html#use_common_alert_schema MonitorActionGroup#use_common_alert_schema}.
     *
     * @stability stable
     */
    readonly useCommonAlertSchema?: boolean | cdktf.IResolvable;
}
export declare function monitorActionGroupEmailReceiverToTerraform(struct?: MonitorActionGroupEmailReceiver): any;
/**
 * @stability stable
 */
export interface MonitorActionGroupItsmReceiver {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/monitor_action_group.html#connection_id MonitorActionGroup#connection_id}.
     *
     * @stability stable
     */
    readonly connectionId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/monitor_action_group.html#name MonitorActionGroup#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/monitor_action_group.html#region MonitorActionGroup#region}.
     *
     * @stability stable
     */
    readonly region: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/monitor_action_group.html#ticket_configuration MonitorActionGroup#ticket_configuration}.
     *
     * @stability stable
     */
    readonly ticketConfiguration: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/monitor_action_group.html#workspace_id MonitorActionGroup#workspace_id}.
     *
     * @stability stable
     */
    readonly workspaceId: string;
}
export declare function monitorActionGroupItsmReceiverToTerraform(struct?: MonitorActionGroupItsmReceiver): any;
/**
 * @stability stable
 */
export interface MonitorActionGroupLogicAppReceiver {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/monitor_action_group.html#callback_url MonitorActionGroup#callback_url}.
     *
     * @stability stable
     */
    readonly callbackUrl: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/monitor_action_group.html#name MonitorActionGroup#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/monitor_action_group.html#resource_id MonitorActionGroup#resource_id}.
     *
     * @stability stable
     */
    readonly resourceId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/monitor_action_group.html#use_common_alert_schema MonitorActionGroup#use_common_alert_schema}.
     *
     * @stability stable
     */
    readonly useCommonAlertSchema?: boolean | cdktf.IResolvable;
}
export declare function monitorActionGroupLogicAppReceiverToTerraform(struct?: MonitorActionGroupLogicAppReceiver): any;
/**
 * @stability stable
 */
export interface MonitorActionGroupSmsReceiver {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/monitor_action_group.html#country_code MonitorActionGroup#country_code}.
     *
     * @stability stable
     */
    readonly countryCode: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/monitor_action_group.html#name MonitorActionGroup#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/monitor_action_group.html#phone_number MonitorActionGroup#phone_number}.
     *
     * @stability stable
     */
    readonly phoneNumber: string;
}
export declare function monitorActionGroupSmsReceiverToTerraform(struct?: MonitorActionGroupSmsReceiver): any;
/**
 * @stability stable
 */
export interface MonitorActionGroupTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/monitor_action_group.html#create MonitorActionGroup#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/monitor_action_group.html#delete MonitorActionGroup#delete}.
     *
     * @stability stable
     */
    readonly delete?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/monitor_action_group.html#read MonitorActionGroup#read}.
     *
     * @stability stable
     */
    readonly read?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/monitor_action_group.html#update MonitorActionGroup#update}.
     *
     * @stability stable
     */
    readonly update?: string;
}
export declare function monitorActionGroupTimeoutsToTerraform(struct?: MonitorActionGroupTimeoutsOutputReference | MonitorActionGroupTimeouts): any;
/**
 * @stability stable
 */
export declare class MonitorActionGroupTimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): MonitorActionGroupTimeouts | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: MonitorActionGroupTimeouts | undefined);
    private _create?;
    /**
     * @stability stable
     */
    get create(): string;
    /**
     * @stability stable
     */
    set create(value: string);
    /**
     * @stability stable
     */
    resetCreate(): void;
    /**
     * @stability stable
     */
    get createInput(): string | undefined;
    private _delete?;
    /**
     * @stability stable
     */
    get delete(): string;
    /**
     * @stability stable
     */
    set delete(value: string);
    /**
     * @stability stable
     */
    resetDelete(): void;
    /**
     * @stability stable
     */
    get deleteInput(): string | undefined;
    private _read?;
    /**
     * @stability stable
     */
    get read(): string;
    /**
     * @stability stable
     */
    set read(value: string);
    /**
     * @stability stable
     */
    resetRead(): void;
    /**
     * @stability stable
     */
    get readInput(): string | undefined;
    private _update?;
    /**
     * @stability stable
     */
    get update(): string;
    /**
     * @stability stable
     */
    set update(value: string);
    /**
     * @stability stable
     */
    resetUpdate(): void;
    /**
     * @stability stable
     */
    get updateInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface MonitorActionGroupVoiceReceiver {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/monitor_action_group.html#country_code MonitorActionGroup#country_code}.
     *
     * @stability stable
     */
    readonly countryCode: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/monitor_action_group.html#name MonitorActionGroup#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/monitor_action_group.html#phone_number MonitorActionGroup#phone_number}.
     *
     * @stability stable
     */
    readonly phoneNumber: string;
}
export declare function monitorActionGroupVoiceReceiverToTerraform(struct?: MonitorActionGroupVoiceReceiver): any;
/**
 * @stability stable
 */
export interface MonitorActionGroupWebhookReceiverAadAuth {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/monitor_action_group.html#identifier_uri MonitorActionGroup#identifier_uri}.
     *
     * @stability stable
     */
    readonly identifierUri?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/monitor_action_group.html#object_id MonitorActionGroup#object_id}.
     *
     * @stability stable
     */
    readonly objectId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/monitor_action_group.html#tenant_id MonitorActionGroup#tenant_id}.
     *
     * @stability stable
     */
    readonly tenantId?: string;
}
export declare function monitorActionGroupWebhookReceiverAadAuthToTerraform(struct?: MonitorActionGroupWebhookReceiverAadAuthOutputReference | MonitorActionGroupWebhookReceiverAadAuth): any;
/**
 * @stability stable
 */
export declare class MonitorActionGroupWebhookReceiverAadAuthOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): MonitorActionGroupWebhookReceiverAadAuth | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: MonitorActionGroupWebhookReceiverAadAuth | undefined);
    private _identifierUri?;
    /**
     * @stability stable
     */
    get identifierUri(): string;
    /**
     * @stability stable
     */
    set identifierUri(value: string);
    /**
     * @stability stable
     */
    resetIdentifierUri(): void;
    /**
     * @stability stable
     */
    get identifierUriInput(): string | undefined;
    private _objectId?;
    /**
     * @stability stable
     */
    get objectId(): string;
    /**
     * @stability stable
     */
    set objectId(value: string);
    /**
     * @stability stable
     */
    get objectIdInput(): string | undefined;
    private _tenantId?;
    /**
     * @stability stable
     */
    get tenantId(): string;
    /**
     * @stability stable
     */
    set tenantId(value: string);
    /**
     * @stability stable
     */
    resetTenantId(): void;
    /**
     * @stability stable
     */
    get tenantIdInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface MonitorActionGroupWebhookReceiver {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/monitor_action_group.html#name MonitorActionGroup#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/monitor_action_group.html#service_uri MonitorActionGroup#service_uri}.
     *
     * @stability stable
     */
    readonly serviceUri: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/monitor_action_group.html#use_common_alert_schema MonitorActionGroup#use_common_alert_schema}.
     *
     * @stability stable
     */
    readonly useCommonAlertSchema?: boolean | cdktf.IResolvable;
    /**
     * aad_auth block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/monitor_action_group.html#aad_auth MonitorActionGroup#aad_auth}
     *
     * @stability stable
     */
    readonly aadAuth?: MonitorActionGroupWebhookReceiverAadAuth;
}
export declare function monitorActionGroupWebhookReceiverToTerraform(struct?: MonitorActionGroupWebhookReceiver): any;
/**
 * Represents a {@link https://www.terraform.io/docs/providers/azurerm/r/monitor_action_group.html azurerm_monitor_action_group}.
 *
 * @stability stable
 */
export declare class MonitorActionGroup extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/azurerm/r/monitor_action_group.html azurerm_monitor_action_group} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: MonitorActionGroupConfig);
    private _enabled?;
    /**
     * @stability stable
     */
    get enabled(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set enabled(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetEnabled(): void;
    /**
     * @stability stable
     */
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _resourceGroupName?;
    /**
     * @stability stable
     */
    get resourceGroupName(): string;
    /**
     * @stability stable
     */
    set resourceGroupName(value: string);
    /**
     * @stability stable
     */
    get resourceGroupNameInput(): string | undefined;
    private _shortName?;
    /**
     * @stability stable
     */
    get shortName(): string;
    /**
     * @stability stable
     */
    set shortName(value: string);
    /**
     * @stability stable
     */
    get shortNameInput(): string | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _armRoleReceiver?;
    /**
     * @stability stable
     */
    get armRoleReceiver(): MonitorActionGroupArmRoleReceiver[];
    /**
     * @stability stable
     */
    set armRoleReceiver(value: MonitorActionGroupArmRoleReceiver[]);
    /**
     * @stability stable
     */
    resetArmRoleReceiver(): void;
    /**
     * @stability stable
     */
    get armRoleReceiverInput(): MonitorActionGroupArmRoleReceiver[] | undefined;
    private _automationRunbookReceiver?;
    /**
     * @stability stable
     */
    get automationRunbookReceiver(): MonitorActionGroupAutomationRunbookReceiver[];
    /**
     * @stability stable
     */
    set automationRunbookReceiver(value: MonitorActionGroupAutomationRunbookReceiver[]);
    /**
     * @stability stable
     */
    resetAutomationRunbookReceiver(): void;
    /**
     * @stability stable
     */
    get automationRunbookReceiverInput(): MonitorActionGroupAutomationRunbookReceiver[] | undefined;
    private _azureAppPushReceiver?;
    /**
     * @stability stable
     */
    get azureAppPushReceiver(): MonitorActionGroupAzureAppPushReceiver[];
    /**
     * @stability stable
     */
    set azureAppPushReceiver(value: MonitorActionGroupAzureAppPushReceiver[]);
    /**
     * @stability stable
     */
    resetAzureAppPushReceiver(): void;
    /**
     * @stability stable
     */
    get azureAppPushReceiverInput(): MonitorActionGroupAzureAppPushReceiver[] | undefined;
    private _azureFunctionReceiver?;
    /**
     * @stability stable
     */
    get azureFunctionReceiver(): MonitorActionGroupAzureFunctionReceiver[];
    /**
     * @stability stable
     */
    set azureFunctionReceiver(value: MonitorActionGroupAzureFunctionReceiver[]);
    /**
     * @stability stable
     */
    resetAzureFunctionReceiver(): void;
    /**
     * @stability stable
     */
    get azureFunctionReceiverInput(): MonitorActionGroupAzureFunctionReceiver[] | undefined;
    private _emailReceiver?;
    /**
     * @stability stable
     */
    get emailReceiver(): MonitorActionGroupEmailReceiver[];
    /**
     * @stability stable
     */
    set emailReceiver(value: MonitorActionGroupEmailReceiver[]);
    /**
     * @stability stable
     */
    resetEmailReceiver(): void;
    /**
     * @stability stable
     */
    get emailReceiverInput(): MonitorActionGroupEmailReceiver[] | undefined;
    private _itsmReceiver?;
    /**
     * @stability stable
     */
    get itsmReceiver(): MonitorActionGroupItsmReceiver[];
    /**
     * @stability stable
     */
    set itsmReceiver(value: MonitorActionGroupItsmReceiver[]);
    /**
     * @stability stable
     */
    resetItsmReceiver(): void;
    /**
     * @stability stable
     */
    get itsmReceiverInput(): MonitorActionGroupItsmReceiver[] | undefined;
    private _logicAppReceiver?;
    /**
     * @stability stable
     */
    get logicAppReceiver(): MonitorActionGroupLogicAppReceiver[];
    /**
     * @stability stable
     */
    set logicAppReceiver(value: MonitorActionGroupLogicAppReceiver[]);
    /**
     * @stability stable
     */
    resetLogicAppReceiver(): void;
    /**
     * @stability stable
     */
    get logicAppReceiverInput(): MonitorActionGroupLogicAppReceiver[] | undefined;
    private _smsReceiver?;
    /**
     * @stability stable
     */
    get smsReceiver(): MonitorActionGroupSmsReceiver[];
    /**
     * @stability stable
     */
    set smsReceiver(value: MonitorActionGroupSmsReceiver[]);
    /**
     * @stability stable
     */
    resetSmsReceiver(): void;
    /**
     * @stability stable
     */
    get smsReceiverInput(): MonitorActionGroupSmsReceiver[] | undefined;
    private _timeouts;
    /**
     * @stability stable
     */
    get timeouts(): MonitorActionGroupTimeoutsOutputReference;
    /**
     * @stability stable
     */
    putTimeouts(value: MonitorActionGroupTimeouts): void;
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): MonitorActionGroupTimeouts | undefined;
    private _voiceReceiver?;
    /**
     * @stability stable
     */
    get voiceReceiver(): MonitorActionGroupVoiceReceiver[];
    /**
     * @stability stable
     */
    set voiceReceiver(value: MonitorActionGroupVoiceReceiver[]);
    /**
     * @stability stable
     */
    resetVoiceReceiver(): void;
    /**
     * @stability stable
     */
    get voiceReceiverInput(): MonitorActionGroupVoiceReceiver[] | undefined;
    private _webhookReceiver?;
    /**
     * @stability stable
     */
    get webhookReceiver(): MonitorActionGroupWebhookReceiver[];
    /**
     * @stability stable
     */
    set webhookReceiver(value: MonitorActionGroupWebhookReceiver[]);
    /**
     * @stability stable
     */
    resetWebhookReceiver(): void;
    /**
     * @stability stable
     */
    get webhookReceiverInput(): MonitorActionGroupWebhookReceiver[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
