import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface PostgresqlFlexibleServerConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/postgresql_flexible_server.html#administrator_login PostgresqlFlexibleServer#administrator_login}.
     *
     * @stability stable
     */
    readonly administratorLogin?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/postgresql_flexible_server.html#administrator_password PostgresqlFlexibleServer#administrator_password}.
     *
     * @stability stable
     */
    readonly administratorPassword?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/postgresql_flexible_server.html#backup_retention_days PostgresqlFlexibleServer#backup_retention_days}.
     *
     * @stability stable
     */
    readonly backupRetentionDays?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/postgresql_flexible_server.html#create_mode PostgresqlFlexibleServer#create_mode}.
     *
     * @stability stable
     */
    readonly createMode?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/postgresql_flexible_server.html#delegated_subnet_id PostgresqlFlexibleServer#delegated_subnet_id}.
     *
     * @stability stable
     */
    readonly delegatedSubnetId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/postgresql_flexible_server.html#location PostgresqlFlexibleServer#location}.
     *
     * @stability stable
     */
    readonly location: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/postgresql_flexible_server.html#name PostgresqlFlexibleServer#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/postgresql_flexible_server.html#point_in_time_restore_time_in_utc PostgresqlFlexibleServer#point_in_time_restore_time_in_utc}.
     *
     * @stability stable
     */
    readonly pointInTimeRestoreTimeInUtc?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/postgresql_flexible_server.html#private_dns_zone_id PostgresqlFlexibleServer#private_dns_zone_id}.
     *
     * @stability stable
     */
    readonly privateDnsZoneId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/postgresql_flexible_server.html#resource_group_name PostgresqlFlexibleServer#resource_group_name}.
     *
     * @stability stable
     */
    readonly resourceGroupName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/postgresql_flexible_server.html#sku_name PostgresqlFlexibleServer#sku_name}.
     *
     * @stability stable
     */
    readonly skuName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/postgresql_flexible_server.html#source_server_id PostgresqlFlexibleServer#source_server_id}.
     *
     * @stability stable
     */
    readonly sourceServerId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/postgresql_flexible_server.html#storage_mb PostgresqlFlexibleServer#storage_mb}.
     *
     * @stability stable
     */
    readonly storageMb?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/postgresql_flexible_server.html#tags PostgresqlFlexibleServer#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/postgresql_flexible_server.html#version PostgresqlFlexibleServer#version}.
     *
     * @stability stable
     */
    readonly version?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/postgresql_flexible_server.html#zone PostgresqlFlexibleServer#zone}.
     *
     * @stability stable
     */
    readonly zone?: string;
    /**
     * high_availability block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/postgresql_flexible_server.html#high_availability PostgresqlFlexibleServer#high_availability}
     *
     * @stability stable
     */
    readonly highAvailability?: PostgresqlFlexibleServerHighAvailability;
    /**
     * maintenance_window block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/postgresql_flexible_server.html#maintenance_window PostgresqlFlexibleServer#maintenance_window}
     *
     * @stability stable
     */
    readonly maintenanceWindow?: PostgresqlFlexibleServerMaintenanceWindow;
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/postgresql_flexible_server.html#timeouts PostgresqlFlexibleServer#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: PostgresqlFlexibleServerTimeouts;
}
/**
 * @stability stable
 */
export interface PostgresqlFlexibleServerHighAvailability {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/postgresql_flexible_server.html#mode PostgresqlFlexibleServer#mode}.
     *
     * @stability stable
     */
    readonly mode: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/postgresql_flexible_server.html#standby_availability_zone PostgresqlFlexibleServer#standby_availability_zone}.
     *
     * @stability stable
     */
    readonly standbyAvailabilityZone?: string;
}
export declare function postgresqlFlexibleServerHighAvailabilityToTerraform(struct?: PostgresqlFlexibleServerHighAvailabilityOutputReference | PostgresqlFlexibleServerHighAvailability): any;
/**
 * @stability stable
 */
export declare class PostgresqlFlexibleServerHighAvailabilityOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): PostgresqlFlexibleServerHighAvailability | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: PostgresqlFlexibleServerHighAvailability | undefined);
    private _mode?;
    /**
     * @stability stable
     */
    get mode(): string;
    /**
     * @stability stable
     */
    set mode(value: string);
    /**
     * @stability stable
     */
    get modeInput(): string | undefined;
    private _standbyAvailabilityZone?;
    /**
     * @stability stable
     */
    get standbyAvailabilityZone(): string;
    /**
     * @stability stable
     */
    set standbyAvailabilityZone(value: string);
    /**
     * @stability stable
     */
    resetStandbyAvailabilityZone(): void;
    /**
     * @stability stable
     */
    get standbyAvailabilityZoneInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface PostgresqlFlexibleServerMaintenanceWindow {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/postgresql_flexible_server.html#day_of_week PostgresqlFlexibleServer#day_of_week}.
     *
     * @stability stable
     */
    readonly dayOfWeek?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/postgresql_flexible_server.html#start_hour PostgresqlFlexibleServer#start_hour}.
     *
     * @stability stable
     */
    readonly startHour?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/postgresql_flexible_server.html#start_minute PostgresqlFlexibleServer#start_minute}.
     *
     * @stability stable
     */
    readonly startMinute?: number;
}
export declare function postgresqlFlexibleServerMaintenanceWindowToTerraform(struct?: PostgresqlFlexibleServerMaintenanceWindowOutputReference | PostgresqlFlexibleServerMaintenanceWindow): any;
/**
 * @stability stable
 */
export declare class PostgresqlFlexibleServerMaintenanceWindowOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): PostgresqlFlexibleServerMaintenanceWindow | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: PostgresqlFlexibleServerMaintenanceWindow | undefined);
    private _dayOfWeek?;
    /**
     * @stability stable
     */
    get dayOfWeek(): number;
    /**
     * @stability stable
     */
    set dayOfWeek(value: number);
    /**
     * @stability stable
     */
    resetDayOfWeek(): void;
    /**
     * @stability stable
     */
    get dayOfWeekInput(): number | undefined;
    private _startHour?;
    /**
     * @stability stable
     */
    get startHour(): number;
    /**
     * @stability stable
     */
    set startHour(value: number);
    /**
     * @stability stable
     */
    resetStartHour(): void;
    /**
     * @stability stable
     */
    get startHourInput(): number | undefined;
    private _startMinute?;
    /**
     * @stability stable
     */
    get startMinute(): number;
    /**
     * @stability stable
     */
    set startMinute(value: number);
    /**
     * @stability stable
     */
    resetStartMinute(): void;
    /**
     * @stability stable
     */
    get startMinuteInput(): number | undefined;
}
/**
 * @stability stable
 */
export interface PostgresqlFlexibleServerTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/postgresql_flexible_server.html#create PostgresqlFlexibleServer#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/postgresql_flexible_server.html#delete PostgresqlFlexibleServer#delete}.
     *
     * @stability stable
     */
    readonly delete?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/postgresql_flexible_server.html#read PostgresqlFlexibleServer#read}.
     *
     * @stability stable
     */
    readonly read?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/postgresql_flexible_server.html#update PostgresqlFlexibleServer#update}.
     *
     * @stability stable
     */
    readonly update?: string;
}
export declare function postgresqlFlexibleServerTimeoutsToTerraform(struct?: PostgresqlFlexibleServerTimeoutsOutputReference | PostgresqlFlexibleServerTimeouts): any;
/**
 * @stability stable
 */
export declare class PostgresqlFlexibleServerTimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): PostgresqlFlexibleServerTimeouts | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: PostgresqlFlexibleServerTimeouts | undefined);
    private _create?;
    /**
     * @stability stable
     */
    get create(): string;
    /**
     * @stability stable
     */
    set create(value: string);
    /**
     * @stability stable
     */
    resetCreate(): void;
    /**
     * @stability stable
     */
    get createInput(): string | undefined;
    private _delete?;
    /**
     * @stability stable
     */
    get delete(): string;
    /**
     * @stability stable
     */
    set delete(value: string);
    /**
     * @stability stable
     */
    resetDelete(): void;
    /**
     * @stability stable
     */
    get deleteInput(): string | undefined;
    private _read?;
    /**
     * @stability stable
     */
    get read(): string;
    /**
     * @stability stable
     */
    set read(value: string);
    /**
     * @stability stable
     */
    resetRead(): void;
    /**
     * @stability stable
     */
    get readInput(): string | undefined;
    private _update?;
    /**
     * @stability stable
     */
    get update(): string;
    /**
     * @stability stable
     */
    set update(value: string);
    /**
     * @stability stable
     */
    resetUpdate(): void;
    /**
     * @stability stable
     */
    get updateInput(): string | undefined;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/azurerm/r/postgresql_flexible_server.html azurerm_postgresql_flexible_server}.
 *
 * @stability stable
 */
export declare class PostgresqlFlexibleServer extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/azurerm/r/postgresql_flexible_server.html azurerm_postgresql_flexible_server} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: PostgresqlFlexibleServerConfig);
    private _administratorLogin?;
    /**
     * @stability stable
     */
    get administratorLogin(): string;
    /**
     * @stability stable
     */
    set administratorLogin(value: string);
    /**
     * @stability stable
     */
    resetAdministratorLogin(): void;
    /**
     * @stability stable
     */
    get administratorLoginInput(): string | undefined;
    private _administratorPassword?;
    /**
     * @stability stable
     */
    get administratorPassword(): string;
    /**
     * @stability stable
     */
    set administratorPassword(value: string);
    /**
     * @stability stable
     */
    resetAdministratorPassword(): void;
    /**
     * @stability stable
     */
    get administratorPasswordInput(): string | undefined;
    private _backupRetentionDays?;
    /**
     * @stability stable
     */
    get backupRetentionDays(): number;
    /**
     * @stability stable
     */
    set backupRetentionDays(value: number);
    /**
     * @stability stable
     */
    resetBackupRetentionDays(): void;
    /**
     * @stability stable
     */
    get backupRetentionDaysInput(): number | undefined;
    /**
     * @stability stable
     */
    get cmkEnabled(): string;
    private _createMode?;
    /**
     * @stability stable
     */
    get createMode(): string;
    /**
     * @stability stable
     */
    set createMode(value: string);
    /**
     * @stability stable
     */
    resetCreateMode(): void;
    /**
     * @stability stable
     */
    get createModeInput(): string | undefined;
    private _delegatedSubnetId?;
    /**
     * @stability stable
     */
    get delegatedSubnetId(): string;
    /**
     * @stability stable
     */
    set delegatedSubnetId(value: string);
    /**
     * @stability stable
     */
    resetDelegatedSubnetId(): void;
    /**
     * @stability stable
     */
    get delegatedSubnetIdInput(): string | undefined;
    /**
     * @stability stable
     */
    get fqdn(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _location?;
    /**
     * @stability stable
     */
    get location(): string;
    /**
     * @stability stable
     */
    set location(value: string);
    /**
     * @stability stable
     */
    get locationInput(): string | undefined;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _pointInTimeRestoreTimeInUtc?;
    /**
     * @stability stable
     */
    get pointInTimeRestoreTimeInUtc(): string;
    /**
     * @stability stable
     */
    set pointInTimeRestoreTimeInUtc(value: string);
    /**
     * @stability stable
     */
    resetPointInTimeRestoreTimeInUtc(): void;
    /**
     * @stability stable
     */
    get pointInTimeRestoreTimeInUtcInput(): string | undefined;
    private _privateDnsZoneId?;
    /**
     * @stability stable
     */
    get privateDnsZoneId(): string;
    /**
     * @stability stable
     */
    set privateDnsZoneId(value: string);
    /**
     * @stability stable
     */
    resetPrivateDnsZoneId(): void;
    /**
     * @stability stable
     */
    get privateDnsZoneIdInput(): string | undefined;
    /**
     * @stability stable
     */
    get publicNetworkAccessEnabled(): any;
    private _resourceGroupName?;
    /**
     * @stability stable
     */
    get resourceGroupName(): string;
    /**
     * @stability stable
     */
    set resourceGroupName(value: string);
    /**
     * @stability stable
     */
    get resourceGroupNameInput(): string | undefined;
    private _skuName?;
    /**
     * @stability stable
     */
    get skuName(): string;
    /**
     * @stability stable
     */
    set skuName(value: string);
    /**
     * @stability stable
     */
    resetSkuName(): void;
    /**
     * @stability stable
     */
    get skuNameInput(): string | undefined;
    private _sourceServerId?;
    /**
     * @stability stable
     */
    get sourceServerId(): string;
    /**
     * @stability stable
     */
    set sourceServerId(value: string);
    /**
     * @stability stable
     */
    resetSourceServerId(): void;
    /**
     * @stability stable
     */
    get sourceServerIdInput(): string | undefined;
    private _storageMb?;
    /**
     * @stability stable
     */
    get storageMb(): number;
    /**
     * @stability stable
     */
    set storageMb(value: number);
    /**
     * @stability stable
     */
    resetStorageMb(): void;
    /**
     * @stability stable
     */
    get storageMbInput(): number | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _version?;
    /**
     * @stability stable
     */
    get version(): string;
    /**
     * @stability stable
     */
    set version(value: string);
    /**
     * @stability stable
     */
    resetVersion(): void;
    /**
     * @stability stable
     */
    get versionInput(): string | undefined;
    private _zone?;
    /**
     * @stability stable
     */
    get zone(): string;
    /**
     * @stability stable
     */
    set zone(value: string);
    /**
     * @stability stable
     */
    resetZone(): void;
    /**
     * @stability stable
     */
    get zoneInput(): string | undefined;
    private _highAvailability;
    /**
     * @stability stable
     */
    get highAvailability(): PostgresqlFlexibleServerHighAvailabilityOutputReference;
    /**
     * @stability stable
     */
    putHighAvailability(value: PostgresqlFlexibleServerHighAvailability): void;
    /**
     * @stability stable
     */
    resetHighAvailability(): void;
    /**
     * @stability stable
     */
    get highAvailabilityInput(): PostgresqlFlexibleServerHighAvailability | undefined;
    private _maintenanceWindow;
    /**
     * @stability stable
     */
    get maintenanceWindow(): PostgresqlFlexibleServerMaintenanceWindowOutputReference;
    /**
     * @stability stable
     */
    putMaintenanceWindow(value: PostgresqlFlexibleServerMaintenanceWindow): void;
    /**
     * @stability stable
     */
    resetMaintenanceWindow(): void;
    /**
     * @stability stable
     */
    get maintenanceWindowInput(): PostgresqlFlexibleServerMaintenanceWindow | undefined;
    private _timeouts;
    /**
     * @stability stable
     */
    get timeouts(): PostgresqlFlexibleServerTimeoutsOutputReference;
    /**
     * @stability stable
     */
    putTimeouts(value: PostgresqlFlexibleServerTimeouts): void;
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): PostgresqlFlexibleServerTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
