import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface StaticSiteCustomDomainConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/static_site_custom_domain.html#domain_name StaticSiteCustomDomain#domain_name}.
     *
     * @stability stable
     */
    readonly domainName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/static_site_custom_domain.html#static_site_id StaticSiteCustomDomain#static_site_id}.
     *
     * @stability stable
     */
    readonly staticSiteId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/static_site_custom_domain.html#validation_type StaticSiteCustomDomain#validation_type}.
     *
     * @stability stable
     */
    readonly validationType: string;
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/static_site_custom_domain.html#timeouts StaticSiteCustomDomain#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: StaticSiteCustomDomainTimeouts;
}
/**
 * @stability stable
 */
export interface StaticSiteCustomDomainTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/static_site_custom_domain.html#create StaticSiteCustomDomain#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/static_site_custom_domain.html#delete StaticSiteCustomDomain#delete}.
     *
     * @stability stable
     */
    readonly delete?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/static_site_custom_domain.html#read StaticSiteCustomDomain#read}.
     *
     * @stability stable
     */
    readonly read?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/static_site_custom_domain.html#update StaticSiteCustomDomain#update}.
     *
     * @stability stable
     */
    readonly update?: string;
}
export declare function staticSiteCustomDomainTimeoutsToTerraform(struct?: StaticSiteCustomDomainTimeoutsOutputReference | StaticSiteCustomDomainTimeouts): any;
/**
 * @stability stable
 */
export declare class StaticSiteCustomDomainTimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): StaticSiteCustomDomainTimeouts | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: StaticSiteCustomDomainTimeouts | undefined);
    private _create?;
    /**
     * @stability stable
     */
    get create(): string;
    /**
     * @stability stable
     */
    set create(value: string);
    /**
     * @stability stable
     */
    resetCreate(): void;
    /**
     * @stability stable
     */
    get createInput(): string | undefined;
    private _delete?;
    /**
     * @stability stable
     */
    get delete(): string;
    /**
     * @stability stable
     */
    set delete(value: string);
    /**
     * @stability stable
     */
    resetDelete(): void;
    /**
     * @stability stable
     */
    get deleteInput(): string | undefined;
    private _read?;
    /**
     * @stability stable
     */
    get read(): string;
    /**
     * @stability stable
     */
    set read(value: string);
    /**
     * @stability stable
     */
    resetRead(): void;
    /**
     * @stability stable
     */
    get readInput(): string | undefined;
    private _update?;
    /**
     * @stability stable
     */
    get update(): string;
    /**
     * @stability stable
     */
    set update(value: string);
    /**
     * @stability stable
     */
    resetUpdate(): void;
    /**
     * @stability stable
     */
    get updateInput(): string | undefined;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/azurerm/r/static_site_custom_domain.html azurerm_static_site_custom_domain}.
 *
 * @stability stable
 */
export declare class StaticSiteCustomDomain extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/azurerm/r/static_site_custom_domain.html azurerm_static_site_custom_domain} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: StaticSiteCustomDomainConfig);
    private _domainName?;
    /**
     * @stability stable
     */
    get domainName(): string;
    /**
     * @stability stable
     */
    set domainName(value: string);
    /**
     * @stability stable
     */
    get domainNameInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _staticSiteId?;
    /**
     * @stability stable
     */
    get staticSiteId(): string;
    /**
     * @stability stable
     */
    set staticSiteId(value: string);
    /**
     * @stability stable
     */
    get staticSiteIdInput(): string | undefined;
    /**
     * @stability stable
     */
    get validationToken(): string;
    private _validationType?;
    /**
     * @stability stable
     */
    get validationType(): string;
    /**
     * @stability stable
     */
    set validationType(value: string);
    /**
     * @stability stable
     */
    get validationTypeInput(): string | undefined;
    private _timeouts;
    /**
     * @stability stable
     */
    get timeouts(): StaticSiteCustomDomainTimeoutsOutputReference;
    /**
     * @stability stable
     */
    putTimeouts(value: StaticSiteCustomDomainTimeouts): void;
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): StaticSiteCustomDomainTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
